package ml;

import ml.active.*;
import weka.core.*;
import weka.active.*;

import ml.util.config.*;

public class ActiveLearning {
    private XActiveLearner learner;

    public ActiveLearning() {
        System.out.println("running with PASSIVE");
        learner = new PASSIVE();
        /*try {
            learner = ActiveLearningAlgsFactory.create(learningAlg);
            learner.startActiveLearningSession();

                 } catch (Exception exp) {
            exp.printStackTrace();
            System.out.println("\n Terminating This Session.. \n");
            System.exit(1);
                 }*/
    }

    public void init(DataContainer data) {
        try {
            learner.buildClassifier(data);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public double[] classify(DataContainer data) throws Exception {
        double[] res = new double[data.size()];
        for (int i = 0, test = data.size(); i < test; ++i) {
            res[i] = learner.classifyInstance(data.getInstance(i));
        }
        return res;
    }

    public int indexToQuery(DataContainer pool) throws Exception {
        return learner.instanceToQuery(pool);
    }

    public DataContainer create(String dataFile) throws Exception {
        return learner.create(dataFile);
    }

    public DataContainer create(double[][] attributes, double[] labels) throws
            Exception {
        return learner.create(attributes, labels);
    }

    public static void main(String[] args) {
          try {
              XmlReadOnlyConfig config = new XmlReadOnlyConfig();
              config.init("config/config.xml");

              String []run_args = {"-t", config.get("run/dataset"),
                                  "-o", config.get("run/resFile"),
                                  "-x", config.get("run/folds"),
                                  "-m",config.get("run/num_query")};

              LearnersFactory factory = new LearnersFactory();

              XActiveLearner learner = factory.create(config.get("run/alg"), config);

              System.out.println(XActiveEvaluationPlotter.evaluateModelAndPlot(
                      learner, run_args));
          } catch (Exception e) {
              System.err.println(e.getMessage());
              e.printStackTrace();
          }

    }
}
