package ml.active;

import ml.util.config.ReadOnlyConfiguration;

public class LearnersFactory {
    public LearnersFactory() {
    }

    public XActiveLearner create(String learner, ReadOnlyConfiguration config) throws
            CreationException {
        XActiveLearner activeLearner = null;

        System.out.println("loading learner: "+learner);
        if (learner.equals(PASSIVE.ID)) {
            activeLearner = new PASSIVE();
        } else if (learner.equals(ACTIVE.ID)) {
            activeLearner = new ACTIVE();
        } else if (learner.equals(FSAL.ID)) {
            activeLearner = new FSAL();
        } else {
            throw new CreationException("ILL Learner String: " + learner);
        }

        activeLearner.init(config);
        return activeLearner;
    }
}
