package ml.active;

import weka.core.*;
import ml.util.config.ReadOnlyConfiguration;

public class PASSIVE extends XSvmActiveLearner {
    public static final String ID = "PASSIVE";

    public PASSIVE() {
        super();
    }

    public int instanceToQuery(DataContainer pool) throws Exception {
        int i, closest = -1;
        int size = pool.size();
        InstanceContainer ins;
        double minConf = Double.MAX_VALUE, currConf;

        for (i = 0; i < size; i++) {
            ins = pool.getInstance(i);
            currConf = Math.abs(getSvm().confindenceOnInstance(ins));
            if (Utils.smOrEq(currConf, minConf)) {
                minConf = currConf;
                closest = i;
            }
        }
        return closest;
    }

    public void init(ReadOnlyConfiguration config) throws CreationException{
        super.init(config);
    }
}
